//////////////////////////////////////////////////////////////////////
// Adopted by Xiaowei Zhan 
// 
// mach2dat/LogisticRegression.h
// (c) 2008 Yun Li
//
// March 15, 2008
//

// To dos for this logistisc regression routine 
// 1. take care of linearly dependent covriate columns (check R)
// 2. exact logistic regression (check the algorithm used in SAS)


#ifndef __LOGISTIC_REGRESSION_H__
#define __LOGISTIC_REGRESSION_H__

#include "MathMatrix.h"
#include "MathCholesky.h"
#include "StringHash.h"
#include "StringArray.h"

class Pedigree;

class LogisticRegression
{
public:
	LogisticRegression();
	~LogisticRegression();

	bool FitLogisticModel(Matrix & X, Vector & y, int rnrounds); // return false if not converging
	bool FitLogisticModel(Matrix & X, Vector & succ, Vector& total, int nrrounds);
	double GetDeviance(Matrix & X, Vector & y);
	double GetDeviance(Matrix & X, Vector & succ, Vector& total);
	Vector & GetAsyPvalue();
	Vector & GetCovEst();
	Matrix & GetCovB();
	void reset(Matrix& X); // get everything cleared
	
	Vector B;       // coefficient vector
	Matrix covB;    // coefficient covariance matrix
	
private:
	Vector pValue;
	Vector p, V, W;
	Vector residuals;
	Vector deltaB;
	Matrix D;
	Matrix testSummary;
	Matrix Dinv;
	Cholesky chol;
	Matrix Dtwo;
	Matrix XtV;

};

#endif



